/*
 @licstart  The following is the entire license notice for the JavaScript code in this file.

 The MIT License (MIT)

 Copyright (C) 1997-2020 by Dimitri van Heesch

 Permission is hereby granted, free of charge, to any person obtaining a copy of this software
 and associated documentation files (the "Software"), to deal in the Software without restriction,
 including without limitation the rights to use, copy, modify, merge, publish, distribute,
 sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is
 furnished to do so, subject to the following conditions:

 The above copyright notice and this permission notice shall be included in all copies or
 substantial portions of the Software.

 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING
 BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
 DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

 @licend  The above is the entire license notice for the JavaScript code in this file
*/
var NAVTREE =
[
  [ "QM", "index.html", [
    [ "About QM™", "index.html", "index" ],
    [ "Getting Started", "gs.html", "gs" ],
    [ "User Interface", "ui.html", "ui" ],
    [ "Basic Modeling", "bm.html", "bm" ],
    [ "State Machines", "sm.html", "sm" ],
    [ "Code Engineering", "ce.html", "ce" ],
    [ "Revision History", "history.html", [
      [ "Version 5.1.3, 2021-06-17", "history.html#qm_5_1_3", null ],
      [ "Version 5.1.1, 2021-04-12", "history.html#qm_5_1_1", null ],
      [ "Version 5.1.0, 2020-11-01", "history.html#qm_5_1_0", null ],
      [ "Version 5.0.4, 2020-09-10", "history.html#qm_5_0_4", null ],
      [ "Version 5.0.3, 2020-08-14", "history.html#qm_5_0_3", null ],
      [ "Version 5.0.2, 2020-07-17", "history.html#qm_5_0_2", null ],
      [ "Version 5.0.1, 2020-04-22", "history.html#qm_5_0_1", null ],
      [ "Version 5.0.0, 2020-03-31", "history.html#qm_5_0_0", null ],
      [ "Version 4.6.0, 2019-12-30", "history.html#qm_4_6_0", null ],
      [ "Version 4.5.1, 2019-05-06", "history.html#qm_4_5_1", null ],
      [ "Version 4.5.0, 2019-03-30", "history.html#qm_4_5_0", null ],
      [ "Version 4.4.0, 2019-02-22", "history.html#qm_4_4_0", null ],
      [ "Version 4.3.1, 2018-09-10", "history.html#qm_4_3_1", null ],
      [ "Version 4.3.0, 2018-06-24", "history.html#qm_4_3_0", null ],
      [ "Version 4.2.1, 2018-05-20", "history.html#qm_4_2_1", null ],
      [ "Version 4.2.0, 2018-05-04", "history.html#qm_4_2_0", null ],
      [ "Version 4.1.2, 2018-03-05", "history.html#qm_4_1_2", null ],
      [ "Version 4.1.1, 2018-01-10", "history.html#qm_4_1_1", null ],
      [ "Version 4.1.0, 2017-11-10", "history.html#qm_4_1_0", null ],
      [ "Version 4.0.3, 2017-05-30", "history.html#qm_4_0_3", null ],
      [ "Version 4.0.2, 2017-05-26", "history.html#qm_4_0_2", null ],
      [ "Version 4.0.1, 2017-04-05", "history.html#qm_4_0_1", null ],
      [ "Version 4.0.0, 2016-12-07", "history.html#qm_4_0_0", null ],
      [ "Version 3.3.0, 2015-05-15", "history.html#qm_3_3_0", null ],
      [ "Version 3.2.2, 2014-10-16", "history.html#qm_3_2_2", null ],
      [ "Version 3.2.1, 2014-10-09", "history.html#qm_3_2_1", null ],
      [ "Version 3.2.0, 2014-08-02", "history.html#qm_3_2_0", null ],
      [ "Version 3.1.3, 2014-04-30", "history.html#qm_3_1_3", null ],
      [ "Version 3.1.3, 2014-04-25", "history.html#qm_3_1_2", null ],
      [ "Version 3.1.1, 2014-04-15", "history.html#qm_3_1_1", null ],
      [ "Version 3.1.0, 2014-03-31", "history.html#qm_3_1_0", null ],
      [ "Version 3.0.1, 2014-01-07", "history.html#qm_3_0_1", null ],
      [ "Version 3.0.0, 2014-01-01", "history.html#qm_3_0_0", null ],
      [ "Version 2.3.2, 2013-05-20", "history.html#qm_2_3_2", null ],
      [ "Version 2.3.1, 2013-05-16", "history.html#qm_2_3_1", null ],
      [ "Version 2.3.0, 2013-05-15", "history.html#qm_2_3_0", null ],
      [ "Version 2.2.03, 2012-09-10", "history.html#qm_2_2_03", null ],
      [ "Version 2.2.02, 2012-09-02", "history.html#qm_2_2_02", null ],
      [ "Version 2.2.01, 2012-08-14", "history.html#qm_2_2_01", null ],
      [ "Version 2.2.00, 2012-08-06", "history.html#qm_2_2_00", null ],
      [ "Version 2.1.02, 2011-12-28", "history.html#qm_2_1_02", null ],
      [ "Version 2.1.01, 2011-11-04", "history.html#qm_2_1_01", null ],
      [ "Version 2.1.00, 2011-10-20", "history.html#qm_2_1_00", null ],
      [ "Version 2.0.00, 2011-09-21", "history.html#qm_2_0_0", null ],
      [ "Version 1.1.08, 2011-08-11", "history.html#qm_1_1_08", null ],
      [ "Version 1.1.07, 2011-06-23", "history.html#qm_1_1_07", null ],
      [ "Version 1.1.06, 2011-04-27", "history.html#qm_1_1_06", null ],
      [ "Version 1.1.05, 2011-04-22", "history.html#qm_1_1_05", null ],
      [ "Version 1.1.04, 2011-03-18", "history.html#qm_1_1_04", null ],
      [ "Version 1.1.03, 2011-03-02", "history.html#qm_1_1_03", null ],
      [ "Version 1.1.02, 2011-01-05", "history.html#qm_1_1_02", null ],
      [ "Version 1.1.01, 2011-01-01", "history.html#qm_1_1_01", null ],
      [ "Version 1.1.00, 2010-12-30", "history.html#qm_1_1_00", null ],
      [ "Version 1.0.08, 2010-12-12", "history.html#qm_1_0_08", null ],
      [ "Version 1.0.07, 2010-11-27", "history.html#qm_1_0_07", null ],
      [ "Version 1.0.06, 2010-11-20", "history.html#qm_1_0_06", null ],
      [ "Version 1.0.05, 2010-11-17", "history.html#qm_1_0_05", null ],
      [ "Version 1.0.04, 2010-11-17", "history.html#qm_1_0_04", null ],
      [ "Version 1.0.03, 2010-10-29", "history.html#qm_1_0_03", null ],
      [ "Version 1.0.00, 2010-10-20", "history.html#qm_1_0_00", null ]
    ] ],
    [ "Quick Links", "links.html", null ],
    [ "Index", "idx.html", [
      [ "$", "idx.html#idx_dollar", null ],
      [ "A", "idx.html#idx_a", null ],
      [ "B", "idx.html#idx_b", null ],
      [ "C", "idx.html#idx_c", null ],
      [ "D", "idx.html#idx_d", null ],
      [ "E", "idx.html#idx_e", null ],
      [ "F", "idx.html#idx_f", null ],
      [ "G", "idx.html#idx_g", null ],
      [ "H", "idx.html#idx_h", null ],
      [ "I", "idx.html#idx_i", null ],
      [ "J", "idx.html#idx_j", null ],
      [ "K", "idx.html#idx_k", null ],
      [ "L", "idx.html#idx_l", null ],
      [ "M", "idx.html#idx_m", null ],
      [ "N", "idx.html#idx_n", null ],
      [ "O", "idx.html#idx_o", null ],
      [ "P", "idx.html#idx_p", null ],
      [ "Q", "idx.html#idx_q", null ],
      [ "R", "idx.html#idx_r", null ],
      [ "S", "idx.html#idx_s", null ],
      [ "T", "idx.html#idx_t", null ],
      [ "U", "idx.html#idx_u", null ],
      [ "V", "idx.html#idx_v", null ],
      [ "W", "idx.html#idx_w", null ],
      [ "X", "idx.html#idx_x", null ],
      [ "Y", "idx.html#idx_y", null ],
      [ "Z", "idx.html#idx_z", null ]
    ] ]
  ] ]
];

var NAVTREEINDEX =
[
"bm.html",
"history.html#qm_4_5_0",
"ui_tools-dlg.html#ui_tools-dlg_open"
];

var SYNCONMSG = 'click to disable panel synchronisation';
var SYNCOFFMSG = 'click to enable panel synchronisation';